



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[转] Spring Boot and React hot loader</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[转] Spring Boot and React hot loader</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:30:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>When I develop web applications, I love using React. I'm also a Spring and groovy addict.</p>
<p>Those two stacks make me more productive. Can we have the best of both worlds?</p>
<p>I will show you step by step how I created <a href="https://github.com/geowarin/boot-react" rel="external nofollow noreferrer">this project</a>. Feel free to fiddle with it and give me your feedback.</p>
<h2>Goal</h2>
<p>My perfect stack on the backend is to use Spring boot and groovy. With the latest version of Spring boot, there is a new tool called <a href="https://spring.io/blog/2015/06/17/devtools-in-spring-boot-1-3" rel="external nofollow noreferrer">dev-tools</a> that will automatically reload the embedded server when you recompile your project.</p>
<p>On the frontend, most React developers use <a href="http://webpack.github.io/" rel="external nofollow noreferrer">webpack</a>. React has awesome support for hot reloading with <a href="https://github.com/gaearon/react-hot-loader" rel="external nofollow noreferrer">react-hot-loader</a>. It will magically update your views without requiring you to refresh your browser. Because React encourages your to have a unidirectional data flow, your whole application can use hot reloading every time you save. For this to work, we have to launch a <a href="http://webpack.github.io/docs/webpack-dev-server.html" rel="external nofollow noreferrer">webpack dev server</a>.</p>
<p>The problem when you launch your Spring boot server on the port 8080 and the dev server on the port 3000 is that you will get cross origin requests preventing the two servers from interacting.</p>
<p>We also want to isolate the two projects and make separate gradle modules.</p>
<p>This blog post will show a solution to this problem and will provide an enjoyable dev environment.</p>
<p>This might not be the perfect solution and I'd love any feedback from both communities to help me improve it.</p>
<h2>The backend</h2>
<p>We will generate the backend. To do that, you can go on http://start.spring.io/ and create a <strong>gradle project</strong> using <strong>groovy</strong>, <strong>java 8</strong> and the latest Spring boot (<strong>1.3.0 M2</strong> at the time of writing).</p>
<p>For the dependencies tick <strong>DevTools</strong> and <strong>Web</strong>.</p>
<p>If you want to do it command line style just type the following in your console:</p>
<div>
<pre class="prettyprint linenums"><code>curl https://start.spring.io/starter.tgz \<br />
-d name=boot-react  \<br />
-d bootVersion=1.3.0.M2 \<br />
-d dependencies=devtools,web \<br />
-d language=groovy \<br />
-d JavaVersion=1.8 \<br />
-d type=gradle-project \<br />
-d packageName=react \<br />
-d packaging=jar \<br />
-d artifactId=boot-react \<br />
-d baseDir=boot-react | tar -xzvf -<br />
</code></pre>
</div>
<p>This will create a base project with the latest spring boot, the devtools, groovy and gradle.</p>
<p>Don't forget to generate the gradle wrapper:</p>
<div>
<pre class="prettyprint linenums"><code>gradle wrapper<br />
</code></pre>
</div>
<p>See the <a href="https://github.com/geowarin/boot-react/commit/c290269a9e105688b38dcc6cc0b3293ec85199e6" rel="external nofollow noreferrer">commit</a></p>
<p>Great so now we have tomcat embedded, hot reloading and supernatural groovy strength. The usual.</p>
<p>We will create a simple REST resource that we would like our frontend to consume:</p>
<div>
<pre class="prettyprint linenums"><code>@RestController<br />
class SimpleResource {

    @RequestMapping('/api/simple')<br />
    Map resource() {<br />
        [simple: 'resource']<br />
    }<br />
}<br />
</code></pre>
</div>
<h2>The frontend</h2>
<p>As mentioned before, we want the frontend to be a separated project. We will create a gradle module for that.</p>
<p>At the root of your project add a <code>settings.gradle</code> file with the following content:</p>
<div>
<pre class="prettyprint linenums"><code>include 'frontend'<br />
</code></pre>
</div>
<p>Now, create a <code>frontend</code> directory under the project root and add a build.gradle file in it:</p>
<div>
<pre class="prettyprint linenums"><code>plugins {<br />
    id "com.moowork.node" version "0.10"<br />
}

version '0.0.1'

task bundle(type: NpmTask) {<br />
    args = ['run', 'bundle']<br />
}

task start(type: NpmTask) {<br />
    args = ['start']<br />
}

start.dependsOn(npm_install)<br />
bundle.dependsOn(npm_install)<br />
</code></pre>
</div>
<p>See the <a href="https://github.com/geowarin/boot-react/commit/6788e068c9071d0368879bee8188b7aeb194388e" rel="external nofollow noreferrer">commit</a></p>
<p>We will use the <a href="https://github.com/srs/gradle-node-plugin" rel="external nofollow noreferrer">gradle node plugin</a> to call the two main tasks in our application:</p>
<ul><li><code>npm run bundle</code> will create the minified app in the <code>dist</code> directory</li>
<li><code>npm start</code> will start our dev server</li></ul>
<p>We can call them from the gradle build with <code>./gradlew frontend:start</code> and <code>./gradlew frontend:bundle</code></p>
<p>The content of the project will basically be the same as <a href="https://github.com/gaearon/react-hot-boilerplate" rel="external nofollow noreferrer">react-hot-boilerplate</a></p>
<p>Let's get the sources of this project as a zip file from github and unzip them into the frontend directory. With bash, type the following command at the root of your project:</p>
<div>
<pre class="prettyprint linenums"><code>wget -qO- -O tmp.zip https://github.com/gaearon/react-hot-boilerplate/archive/master.zip &amp;&amp; unzip tmp.zip &amp;&amp; mv react-hot-boilerplate-master/* frontend &amp;&amp; rm -rf react-hot-boilerplate-master &amp;&amp; rm tmp.zip<br />
</code></pre>
</div>
<p>See the <a href="https://github.com/geowarin/boot-react/commit/a3de637d0d94f48d1cdd0379038115e5b98b79d3" rel="external nofollow noreferrer">commit</a></p>
<p>If everything goes well, typing <code>./gradlew fronted:start</code>, will start the react application at <code>http://localhost:3000</code>.</p>
<p>The first problem arises when you <code>ctrl+c</code> out of the gradle build, the server will still hang. You can kill it with <code>killall node</code>. This is a problem I'd like help solving, if you have a solution, please tell me.</p>
<p>In the rest of the article I will use <code>npm start</code> directly, which presupposes that you have <code>npm</code> available on your development machine. The whole build will only require Java.</p>
<p>We will use the <a href="https://github.com/ampedandwired/html-webpack-plugin" rel="external nofollow noreferrer">webpack-html-plugin</a> to automatically generate the index.html page.</p>
<div>
<pre class="prettyprint linenums"><code>npm install --save-dev html-webpack-plugin<br />
</code></pre>
</div>
<p>Since using the document body as a root for our application is a bad practice, we need to tweak the default html template.</p>
<p>I created a file called <code>index-template.html</code> in a newly created <code>assets</code> directory. It will serve as a template to generate our <code>index.html</code> file:</p>
<div>&nbsp;</div>
<table>
<tbody>
<tr>
<td>&lt;!DOCTYPE html&gt;</td>
</tr>
<tr>
<td>&lt;html{% if(o.htmlWebpackPlugin.files.manifest) { %} manifest="{%= o.htmlWebpackPlugin.files.manifest %}"{% } %}&gt;</td>
</tr>
<tr>
<td>&lt;head&gt;</td>
</tr>
<tr>
<td>&lt;meta charset="UTF-8"&gt;</td>
</tr>
<tr>
<td>&lt;title&gt;{%=o.htmlWebpackPlugin.options.title || 'Webpack App'%}&lt;/title&gt;</td>
</tr>
<tr>
<td>{% if (o.htmlWebpackPlugin.files.favicon) { %}</td>
</tr>
<tr>
<td>&lt;link rel="shortcut icon" href="{%=o.htmlWebpackPlugin.files.favicon%}"&gt;</td>
</tr>
<tr>
<td>{% } %}</td>
</tr>
<tr>
<td>{% for (var css in o.htmlWebpackPlugin.files.css) { %}</td>
</tr>
<tr>
<td>&lt;link href="{%=o.htmlWebpackPlugin.files.css[css] %}" rel="stylesheet"&gt;</td>
</tr>
<tr>
<td>{% } %}</td>
</tr>
<tr>
<td>&lt;/head&gt;</td>
</tr>
<tr>
<td>&lt;body&gt;</td>
</tr>
<tr>
<td>&lt;div id="root"&gt;&lt;/div&gt;</td>
</tr>
<tr>
<td>{% for (var chunk in o.htmlWebpackPlugin.files.chunks) { %}</td>
</tr>
<tr>
<td>&lt;script src="{%=o.htmlWebpackPlugin.files.chunks[chunk].entry %}"&gt;&lt;/script&gt;</td>
</tr>
<tr>
<td>{% } %}</td>
</tr>
<tr>
<td>&lt;/body&gt;</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>&lt;/html&gt;</td>
</tr>
</tbody>
</table>
<div><a href="https://gist.github.com/geowarin/4e6089bc670d753f2453/raw/2652e5223eff529dd6d708717bf393df405de046/index-template.html" rel="external nofollow noreferrer">view raw</a> <a href="https://gist.github.com/geowarin/4e6089bc670d753f2453#file-index-template-html" rel="external nofollow noreferrer">index-template.html</a> hosted with ❤ by <a href="https://github.com" rel="external nofollow noreferrer">GitHub</a></div>
<p>As you can see, it contains a div with the id <code>root</code>.</p>
<p>Let's tweak the dev server a little bit to <a href="http://webpack.github.io/docs/webpack-dev-server.html#combining-with-an-existing-server" rel="external nofollow noreferrer">combine it with another server</a>.</p>
<p>Let's change <code>webpack.config.js</code>:</p>
<div>
<pre class="prettyprint linenums"><code>var path = require('path');<br />
var webpack = require('webpack');<br />
var HtmlWebpackPlugin = require('html-webpack-plugin');

module.exports = {<br />
  devtool: 'eval',<br />
  entry: [<br />
    'webpack-dev-server/client?http://localhost:3000',<br />
    'webpack/hot/only-dev-server',<br />
    './src/index'<br />
  ],<br />
  output: {<br />
    path: path.join(__dirname, 'dist'),<br />
    filename: 'bundle.js',<br />
    publicPath: 'http://localhost:3000/'<br />
  },<br />
  plugins: [<br />
    new webpack.HotModuleReplacementPlugin(),<br />
    new webpack.NoErrorsPlugin(),<br />
    new HtmlWebpackPlugin({<br />
      title: 'Boot React',<br />
      template: path.join(__dirname, 'assets/index-template.html')<br />
    })<br />
  ],<br />
  resolve: {<br />
    extensions: ['', '.js']<br />
  },<br />
  module: {<br />
    loaders: [{<br />
      test: /\.js$/,<br />
      loaders: ['react-hot', 'babel'],<br />
      include: path.join(__dirname, 'src')<br />
    }]<br />
  }<br />
};<br />
</code></pre>
</div>
<p>We changed the <code>publicPath</code> to point directly at our dev server and included the <code>HtmlWebpackPlugin</code>.</p>
<p>Now we can get rid of the old index.html and start our dev server with <code>npm start</code>. The index will be automatically generated for us.</p>
<p>See the <a href="https://github.com/geowarin/boot-react/commit/10e3fdae8ac53bea40c585076363a4cc54ed9d9e" rel="external nofollow noreferrer">commit</a></p>
<h2>Include the frontend in the boot jar</h2>
<p>We have to create the npm <code>bundle</code> task, which will generate an optimized web application in the <code>dist</code> directory.</p>
<p>In the <code>package.json</code> file, update the <code>scripts</code>:</p>
<div>
<pre class="prettyprint linenums"><code>"scripts": {<br />
  "start": "node server.js",<br />
  "bundle": "webpack --optimize-minimize --optimize-dedupe --output-public-path ''"<br />
}<br />
</code></pre>
</div>
<p>Now if you launch <code>./gradlew frontend:bundle</code>, it will generate an optimized <code>bundle.js</code> file and the <code>index.html</code> in the <code>dist</code> directory.</p>
<p>The last step is to include this <code>dist</code> directory in our application's jar as static assets. Add the following task to our main gradle build:</p>
<div>
<pre class="prettyprint linenums"><code>jar {<br />
  from('frontend/dist') {<br />
    into 'static'<br />
  }<br />
}

processResources.dependsOn('frontend:bundle')<br />
</code></pre>
</div>
<p>If you generate your jar with <code>./gradlew assemble</code>, you will see that the built jar includes the frontend resources.</p>
<p>If you run the jar (<code>java -jar build/libs/boot-react-0.0.1-SNAPSHOT.jar</code>), you should see the React hello world on <code>localhost:8080</code></p>
<p>See the <a href="https://github.com/geowarin/boot-react/commit/99b89a19200fe847bc0740346a0c4e5668b4e3c2" rel="external nofollow noreferrer">commit</a></p>
<h2>Launch it in dev</h2>
<p>When working on our application, it would be nice if:</p>
<ol><li>Launching the spring boot server in dev launched the webpack dev server</li>
<li>Our dev-server proxied the request to <code>localhost:8080</code> so we can access the application on <code>localhost:3000</code> and not get cross-origin requests</li></ol>
<p>Add the following <code>WebpackLauncher</code> to the project:</p>
<div>
<pre class="prettyprint linenums"><code>@Configuration<br />
@Profile('dev')<br />
class WebpackLauncher {

  @Bean<br />
  WebpackRunner frontRunner() {<br />
    new WebpackRunner()<br />
  }

  class WebpackRunner implements InitializingBean {<br />
    static final String WEBPACK_SERVER_PROPERTY = 'webpack-server-loaded'

    static boolean isWindows() {<br />
      System.getProperty('os.name').toLowerCase().contains('windows')<br />
    }

    @Override<br />
    void afterPropertiesSet() throws Exception {<br />
      if (!System.getProperty(WEBPACK_SERVER_PROPERTY)) {<br />
        startWebpackDevServer()<br />
      }<br />
    }

    private void startWebpackDevServer() {<br />
      String cmd = isWindows() ? 'cmd /c npm start' : 'npm start'<br />
      cmd.execute(null, new File('frontend')).consumeProcessOutput(System.out, System.err)<br />
      System.setProperty(WEBPACK_SERVER_PROPERTY, 'true')<br />
    }<br />
  }<br />
}<br />
</code></pre>
</div>
<p>This will take care of the first task by launching <code>npm start</code> when our server starts. I used a system property to make sure the dev-tools will not reload the frontend when we make a change in the backend code. This class will be available when we start the application with the <code>dev</code> <a href="http://docs.spring.io/spring-boot/docs/current/reference/html/boot-features-profiles.html" rel="external nofollow noreferrer">profile</a></p>
<p>We can make a simple proxy with webpack-dev-server. Change the <code>server.js</code> file:</p>
<div>
<pre class="prettyprint linenums"><code>var webpack = require('webpack');<br />
var WebpackDevServer = require('webpack-dev-server');<br />
var config = require('./webpack.dev.config');

new WebpackDevServer(webpack(config), {<br />
  publicPath: config.output.publicPath,<br />
  hot: true,<br />
  historyApiFallback: true,<br />
  proxy: {<br />
    "*": "http://localhost:8080"<br />
  }<br />
}).listen(3000, 'localhost', function (err, result) {<br />
  if (err) {<br />
    console.log(err);<br />
  }

  console.log('Listening at localhost:3000');<br />
});<br />
</code></pre>
</div>
<p>Launch your application with the <code>--spring.profiles.active=dev</code> flag.</p>
<p>You should be able see the react hello world on <a href="http://localhost:3000" rel="external nofollow noreferrer">http://localhost:3000</a>. If you make some changes to it, it will automatically reload.</p>
<p>See the old commit <a href="https://github.com/geowarin/boot-react/commit/af66c4b2f9798ad50f4e6be30ba5fb6c5f56f79f" rel="external nofollow noreferrer">commit</a></p>
<p>And the new <a href="https://github.com/geowarin/boot-react/commit/2eb6460812c2f2022b49e04f8ed4034dda402c2c" rel="external nofollow noreferrer">commit</a></p>
<h2>Fetch the resource</h2>
<p>We can check that we do not get cross-origin errors using <a href="https://github.com/mzabriskie/axios" rel="external nofollow noreferrer">axios</a>, a simple library to do http requests. It supports promises and automatically handles json.</p>
<div>
<pre class="prettyprint linenums"><code>npm i -S axios<br />
</code></pre>
</div>
<p>Let's amend our <code>App.js</code>:</p>
<div>
<pre class="prettyprint linenums"><code>import React, { Component } from 'react';<br />
import axios from 'axios';

export default class App extends Component {

  componentDidMount() {<br />
    axios.get('/api/simple')<br />
      .then(res =&gt; console.log(res.data))<br />
      .catch(err =&gt; console.error(err))<br />
  }

  render() {<br />
    return (<br />
      &lt;h1&gt;Hello, guys.&lt;/h1&gt;<br />
    );<br />
  }<br />
}<br />
</code></pre>
</div>
<p>See the <a href="https://github.com/geowarin/boot-react/blob/079f0c8afcd8266355b77a094941c8cdbe1349fd/frontend/src/App.js" rel="external nofollow noreferrer">commit</a></p>
<h2>Better optimization of the javascript assets</h2>
<p>We can further improve the compression of the javascript assets by separating our dev webpack configuration from our production configuration.</p>
<p>In the production configuration, we can use the DefinePlugin to set the NODE_ENV variable to production. This will allow webpack to automatically remove all the code intended for development purposes in our libraries:</p>
<div>
<pre class="prettyprint linenums"><code>new webpack.DefinePlugin({<br />
  "process.env": {<br />
    NODE_ENV: JSON.stringify("production")<br />
  }<br />
})<br />
</code></pre>
</div>
<p>See the <a href="https://github.com/geowarin/boot-react/commit/a095ebca7672d2f12bb559e37e01784984a6abc1" rel="external nofollow noreferrer">commit</a></p>
<h2>Feedback needed</h2>
<p>Well, this works pretty well!</p>
<p><img referrerpolicy="no-referrer"src="http://geowarin.github.io/assets/images/articles/2015-08-hot-reload.gif" />Hot hot reload</p>
<p>What do you think? Care to comment and help me make something better? Your feedback is welcome!</p>
<p>The project is available <a href="https://github.com/geowarin/boot-react" rel="external nofollow noreferrer">on github</a>. Pull requests and issues are gladly accepted.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql16k09.html">【JavaScript】图片上传预览</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdowdj8.html">Rdlc报表 数据汇总分组展示</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kggjj9.html">rtabmap&lowbar;ros安装---43</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9320vnq.html">html5 xdm 页面之间的通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1e6pz9.html">小甲鱼PE详解之区块描述、对齐值以及RVA详解（PE详解06）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j001l0q.html">scala中如何编写自定义的流程控制结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oogrv9.html">console的一个小易错点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnjx2rq.html">&lbrack;下载&rsqb; VS 2013 Update 4 &amp;amp&semi; 社群版 &lpar;Visual Studio Community&rpar; &amp;amp&semi; VS 2015 Preview预览版</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k14nmr9.html">CSS属性一览</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj116k9.html">haproxy 超时自动重发</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gejmx78.html">建立Cent OS7server有些问题需要注意</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k56w29.html">ios 集合总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpnl169.html">fputcsv 导出CSV、Excel DownLoad</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo2zj3q.html">&lbrack;COGS2701&rsqb;：动态树</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpy47j9.html">Python全栈学习&lowbar;作业集锦&lpar;持续更新&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvmvnk8.html">python 定义类 简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyz7y39.html">Oracle PL&sol;SQL异常、存储过程和触发器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj27g09.html">Linux系统挂载只读改成读写</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1xer1q.html">NETBEAN 启动报错  CANNOT LOCATE JAVA INSTALLATION IN SPECIFIED JDKHOME的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/902rvwjq.html">cache-control 缓存</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mn61yoq.html">Bag of Words&sol;Bag of Features的Matlab源码发布</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j06ymgq.html">strong ，weak</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm6ng49.html">从1500万用户巅峰跌落的app，血泪回顾图片社交那些坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mvpy1q.html">unity Character Controller  点滴</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j07j60q.html">h&period;264宏块与子宏块类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x1w5r9.html">Oracle自动增长的序列号</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x1pj09.html">JS、C&num;编码解码</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y1p1eq.html">Unity3d HDR和Bloom效果（高动态范围图像和泛光）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmyp7z9.html">手把手教你学习DSP&lowbar;硬件设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1zm439.html">UIImageVIew的使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
